DECLARE @balance           DECIMAL(18,4) = 500.00
       ,@operatorID        NVARCHAR(16)  = 'SYS'
       ,@tvarDynamicQuery  NVARCHAR(MAX) = ''
       ,@tvarDynamicSelect NVARCHAR(MAX) = '';
        
          SELECT @tvarDynamicQuery  += CONCAT(', ', col.[name]),
                 @tvarDynamicSelect += CONCAT(',',CASE
                                                 WHEN col.[name] = 'co_completed'
                                                 THEN '0'
                                                 WHEN col.[name] = 'co_description'
                                                 THEN 'REPLACE(REPLACE(Tbl_Contact.co_description, ''TT1'', ''TT ''), ''AS93'', ''ASDA'')'
                                                 WHEN col.[name] IN ('co_date','co_cdate','co_ctime','co_mdate','co_mtime')
                                                 THEN 'GETDATE()'
                                                 WHEN col.[name] IN ('co_cby','co_mby')
                                                 THEN CONCAT('''', @operatorID, '''')
                                                 ELSE CONCAT('Tbl_Contact.',col.[name])
                                              END
                                              )
            FROM sys.tables  tb
      INNER JOIN sys.all_columns col
              ON tb.[object_id]       = col.[object_id]
           WHERE tb.[type]            = 'U'
             AND tb.[name]            = 'contact'
             AND col.[name]          <> 'co_rowid'
             AND LEFT(col.[name] ,1) <> '_'

IF (OBJECT_ID('tempdb..##clientRowIds') IS NOT NULL)
    DROP TABLE ##clientRowIds;

CREATE TABLE ##clientRowIds ( clRowId BIGINT,  INDEX IX_tempCl_clRowId NONCLUSTERED (clRowId));
     
IF (OBJECT_ID('tempdb..##debtorRowIds') IS NOT NULL)
    DROP TABLE ##debtorRowIds;
        
CREATE TABLE ##debtorRowIds ( deRowId BIGINT,  INDEX IX_tempDe_deRowId NONCLUSTERED (deRowId));

        /* update clients first */
    UPDATE Tbl_client
       SET cl_owing_threshold = @balance
    OUTPUT deleted.cl_rowid INTO ##clientRowIds
      FROM dbo.client Tbl_client
     WHERE cl_type             = 2 
       AND (cl_flags_1 & 2)    = 0
       /*AND cl_owing_threshold != @balance*/

        /* New Accounts, not yet Reported:
            - Delete existing open Contact 
            - un toggle the cbr  de_flags &= ~16
        */
    DELETE Tbl_Contact
    OUTPUT deleted.co_rowid_debtor INTO ##debtorRowIds
      FROM dbo.contact AS Tbl_Contact
INNER JOIN dbo.debtor  AS Tbl_Debtor ON de_rowid = co_rowid_debtor
INNER JOIN dbo.client  AS Tbl_Client ON cl_rowid = de_rowid_client
INNER JOIN ##clientRowIds            ON Tbl_Client.cl_rowid = clRowId
     WHERE Tbl_Contact.co_type                  = 10
       AND Tbl_Contact.co_completed             = 0
       AND ISNULL(Tbl_Contact.co_attachment,'') = ''
       AND CASE
               WHEN Tbl_Client.cl_add_type = 1 THEN ISNULL(Tbl_Debtor.de_principal         , 0)
               WHEN Tbl_Client.cl_add_type = 2 THEN ISNULL(Tbl_Debtor.de_original_principal, 0)
               ELSE                                 ISNULL(Tbl_Debtor.de_owing             , 0)
           END                                  < @balance
       AND Tbl_Contact.co_description        LIKE '%TT1%';
        
        /* Toggle CBR button off */
    UPDATE debtor
       SET de_flags &= ~16
      FROM dbo.debtor
INNER JOIN ##debtorRowIds
        ON de_rowid = deRowId;
        
          
        /* Accounts already Reported, In Progress Contact:
            - Update co_description of existing open Contact
        */
    UPDATE Tbl_Contact
       SET co_description = REPLACE(Tbl_Contact.co_description, 'AS93', 'ASDA')
         , co_date        = CAST(GETDATE() as DATE)
    OUTPUT deleted.co_rowid_debtor INTO ##debtorRowIds
      FROM dbo.contact AS Tbl_Contact
INNER JOIN dbo.debtor  AS Tbl_Debtor ON de_rowid = co_rowid_debtor
INNER JOIN dbo.client  AS Tbl_Client ON cl_rowid = de_rowid_client
INNER JOIN ##clientRowIds            ON Tbl_Client.cl_rowid = clRowId
     WHERE Tbl_Contact.co_type             = 10
       AND Tbl_Contact.co_completed        = 0
       AND CASE
               WHEN Tbl_Client.cl_add_type = 1 THEN ISNULL(Tbl_Debtor.de_principal         , 0)
               WHEN Tbl_Client.cl_add_type = 2 THEN ISNULL(Tbl_Debtor.de_original_principal, 0)
               ELSE                                 ISNULL(Tbl_Debtor.de_owing             , 0)
           END                             < @balance
       AND Tbl_Contact.co_description NOT LIKE '%TT1%'
       AND Tbl_Contact.co_description     LIKE '%AS93%';
        
        /* Accounts already Reported, Completed Contact:
            - Copy the last Contact: set co_completed = 0, co_description as DA, co_date = Today
        */
SELECT @tvarDynamicQuery = CONCAT( ';WITH debtorWithNoInProgressMetroContact AS                                          ',
                           '(     SELECT de_rowid  AS ''deRowId''                                                        ',
                           '        FROM dbo.debtor                                                                      ',
                           '  INNER JOIN dbo.client  AS Tbl_Client ON cl_rowid = de_rowid_client                         ',
                           '  INNER JOIN ##clientRowIds            ON Tbl_Client.cl_rowid = clRowId                      ',
                           '   LEFT JOIN dbo.contact                                                                     ',
                           '          ON co_rowid_debtor = de_rowid                                                      ',
                           '         AND co_type         = 10                                                            ',
                           '         AND co_completed    = 0                                                             ',
                           '    WHERE co_rowid        IS NULL                                                            ',
                           '      AND (de_flags & 16) = 16                                                               ',
                           ')                                                                                            ',
                           ', contactRowIdCTE AS                                                                         ',
                           '(   SELECT Tbl_Contact.co_rowid                     AS ''coRowId'',                          ',
                           '           ROW_NUMBER() OVER ( PARTITION BY Tbl_Contact.co_rowid_debtor                      ',
                           '                                   ORDER BY Tbl_Contact.co_date DESC,                        ',
                           '                                             Tbl_Contact.co_rowid DESC                       ',
                           '                             )               AS ''coOrder'',                                 ',
                           '           Tbl_Contact.co_description        AS ''coDesc''                                   ',
                           '      FROM dbo.contact  Tbl_Contact                                                          ',
                           'INNER JOIN debtorWithNoInProgressMetroContact ON Tbl_Contact.co_rowid_debtor  = deRowId      ',
                           'INNER JOIN dbo.debtor  AS Tbl_Debtor ON de_rowid = co_rowid_debtor                           ',
                           'INNER JOIN dbo.client  AS Tbl_Client ON cl_rowid = de_rowid_client                           ',
                           'INNER JOIN ##clientRowIds            ON Tbl_Client.cl_rowid = clRowId                        ',
                           '     WHERE Tbl_Contact.co_type             = 10                                              ',
                           '       AND Tbl_Contact.co_completed        = 1                                               ',
                           '       AND CASE                                                                              ',
                           '            WHEN Tbl_Client.cl_add_type = 1 THEN ISNULL(Tbl_Debtor.de_principal         , 0) ',
                           '            WHEN Tbl_Client.cl_add_type = 2 THEN ISNULL(Tbl_Debtor.de_original_principal, 0) ',
                           '            ELSE                                 ISNULL(Tbl_Debtor.de_owing             , 0) ',
                           '          END                              <                                                 ', @balance,
                           '       AND Tbl_Contact.co_description NOT LIKE ''%TT1%''                                     ',
                           '       AND Tbl_Contact.co_description     LIKE ''%AS93%''                                    ',
                           ')                                                                                            ',
                           'INSERT INTO dbo.contact (', STUFF(@tvarDynamicQuery,1,1,''), ')                              ',
                           '    OUTPUT inserted.co_rowid_debtor INTO ##debtorRowIds                                      ',
                           '             SELECT ', STUFF(@tvarDynamicSelect,1,1,'')                                       ,
                           '      FROM dbo.contact AS Tbl_Contact                                                        ',
                           'INNER JOIN contactRowIdCTE                                                                   ',
                           '        ON co_rowid = coRowId                                                                ',
                           '       AND coOrder = 1                                                                       ',
                           '       AND coDesc NOT LIKE ''%%AS62%%''                                                      ', 
                           '       AND coDesc NOT LIKE ''%%ASDA%%''                                                      ', 
                           '       AND coDesc NOT LIKE ''%%ASDF%%''                                                      ' 
                          )
EXECUTE sp_executesql @tvarDynamicQuery

        /* make sure the reactivate is OFF */
    UPDATE debtor
       SET de_flags &= ~4096
         , de_mdate  = CAST(GETDATE() as DATE)
         , de_mtime  = CAST(GETDATE() as TIME)
         , de_mby    = @operatorID
      FROM dbo.debtor
INNER JOIN ##debtorRowIds
        ON de_rowid = deRowId;
        